

//this fights for your right to click


var rtc = {



log: function(text)
{
    if (rtcutils.getPref("extensions.rtc.log") > -1)
        Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService)
            .logStringMessage("RightToClick [LL" + rtcutils.getPref('extensions.rtc.log') + "]: " + String(text));
},


Init: function (event) {
    window.removeEventListener("load", rtc.Init, false);
    rtc.IOS = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    rtc.WM = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
    rtc.PROMPTS = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
    rtc.blinkTimer = 0;
    rtc.optionsSetKeys();
    if(appcontent = document.getElementById("appcontent"))
    {
        if (rtcutils.isUserPref("extensions.rtc.firstrun")) {
            if (rtcutils.getPref("extensions.rtc.firstrun") === 0)
                try{rtcutils.clearPref("extensions.rtc.updateflag");rtc.setUpdateFlag(0,1);}catch(e){}
            rtcutils.clearPref("extensions.rtc.firstrun");  //remove old pref, replaced by updateflag
        }
        var updateflag = rtcutils.getPref("extensions.rtc.updateflag");
        if (typeof updateflag === "number") {
            rtcutils.clearPref("extensions.rtc.updateflag");
            rtcutils.setPref('extensions.rtc.updateflag', String(updateflag), 32);
        }
        if (!rtc.getUpdateFlag(1)) {
          rtc.setUpdateFlag(1,1);
          rtc.optionsReset(1);
        }
        rtcutils.setPref('extensions.rtc.statusbar', !!document.getElementById("rtcstatusbarID"));
        var p = rtc.getPrefs();
        rtc.chooseBinding(p[29]);
        rtc.optionsStatBarIcon(p[28]);
        rtc.AddButtonToToolbar();
        appcontent.addEventListener("stop", rtc.onShow, true);
        appcontent.addEventListener("pageshow", rtc.onShow, true);
    }
},




getHost: function(aurl)
{
    if ( !String(aurl).indexOf("file") )
        return "localhost";
    try{
        return rtc.IOS.newURI(String(aurl), null, null).host;
    }catch(e){ return String(aurl).replace(/^([^:]+:\/\/)?([^\/\.]+\.[^\/]+).*/i, "$2"); }
},


captureClick: function(event){
    var rightClick = false;
    if(event.which && event.which == 3)
      rightClick = true;
    else if (event.button && event.button == 2)
      rightClick = true;
    if(!rightClick)//left click
    {
      rtc.buttonrun();
      return;
    }
    //right click...
},


openConfigWindow: function()
{
    window.openDialog('chrome://rtc/content/rtcOptions.xul', '_blank', 'chrome=yes,modal=yes,resizable=no,centerscreen=yes');
},


openTab: function(aURL)
{
    var tabOpener;
    if(aURL && typeof gBrowser != "undefined")
        tabOpener = gBrowser;
    else if (aURL && typeof window.opener != "undefined" && typeof window.opener.gBrowser != "undefined")
        tabOpener = window.opener.gBrowser;
    else return;
    tabOpener.selectedTab = tabOpener.addTab(aURL);
},

populateSBContext: function()
{
    var mPopup = document.getElementById("rtc-statusbarcontextmenu");
    if(!mPopup)
        return;
    while (mPopup.hasChildNodes())
        mPopup.removeChild(mPopup.firstChild);
    //add items
    var mi = mPopup.appendChild(document.createElement("menuitem"));
    mi.setAttribute("oncommand", "rtc.openConfigWindow()");
    mi.setAttribute("label", "Options");
},


buttonrun: function(){
    if(rtc.WM && rtc.WM.getMostRecentWindow("navigator:browser")
    && rtc.WM.getMostRecentWindow("navigator:browser").content)
    {
        var doc = rtc.WM.getMostRecentWindow("navigator:browser").content.document;
        if(rtc.isValidDocument(doc))
          rtc.run(doc, true);
    }
},



parse: function(clicked, imgArr, topwin){ //frames and iframes
  var topwindoc = topwin.document;
  if (rtc.isValidDocument(topwindoc)) {    //TODO: check content-type
  //alert('valid='+topwindoc.location);
      rtc.execute(topwindoc, clicked, imgArr);
  }
  for (var i=0; i < topwin.frames.length; i++)
      rtc.parse(clicked, imgArr, topwin.frames[i]);
},


onKeyCode: function()
{
  rtc.buttonrun();
},



runOnEvent: function(event, clicked) {
    var doc;
    var isDead = false;
    try{ isDead = Components.utils.isDeadWrapper(event.target); }catch(e){}
    if(!isDead)
      doc = event.target;
    if(doc)
      rtc.run(doc, clicked);
    else alert ("RTC: Dead doc!");
},


run: function(doc, clicked) {
    if( (typeof gBrowser != "undefined" && gBrowser.getBrowserForDocument(doc) && !gBrowser.getBrowserForDocument(doc).docShell.allowJavascript) || !rtcutils.prefs.getBoolPref("javascript.enabled") )
    {
        if (!rtcutils.prefs.getBoolPref("extensions.rtc.noWarningScriptDisabled"))
        {
            var check = {value: false};
            rtc.PROMPTS.alertCheck(null, "RightToClick", "Javascript is disabled on this page - nothing to do for RightToClick!", "Do not show this again", check);
            rtcutils.prefs.setBoolPref("extensions.rtc.noWarningScriptDisabled", check.value);
        }
    }

    doc.imgs = [];

    var topwin = doc.defaultView.top;
    rtc.parse(clicked, doc.imgs, topwin); //parse frames and execute RTC (execute, collect images, ...)

    var p = rtc.getPrefs();
    if(p[26])
    {
        doc.documentElement.innerHTML = ""; //build empty document
        var head = doc.createElement('head');
        doc.documentElement.appendChild(head);
        var elem = doc.createElement('title')
        head.appendChild(elem);
        elem.textContent = "RightToClick Image View";
        doc.documentElement.appendChild(doc.createElement('body'));

        elem = doc.createElement('div');
        doc.body.appendChild(elem);
        elem.style.setProperty("max-width", (window.innerWidth - 10) + "px", "important");
        elem.style.setProperty("max-height", (window.innerHeight - 150) + "px", "important");
        elem.style.setProperty("overflow", "auto", "important");

        var known = "";;
        for (i = 0; i < doc.imgs.length; i++) //add collected  images
        {
            if(known.indexOf(doc.imgs[i]) != -1) //prevent duplicates
                    continue;
            known += doc.imgs[i];
            var newimg = doc.createElement('img');
            newimg.src = String(doc.imgs[i]);
            elem.appendChild(newimg); //also recreate background images as normal images
            newimg.style.setProperty("max-width", "350px", "important");
            newimg.style.setProperty("max-height", "350px", "important");
        }

        doc.defaultView.scrollbars.visible = true;
        window.scrollbars.visible = true;
        doc.defaultView.scrollbars.hidden = false;
        window.scrollbars.hidden = false;
    }
    doc.imgs = null;
},




injectScript: function(doc, clicked, imgArr, p, head_tag, m) {
    var pstr = ',';
    for(i = 0; i < p.length; i++){
      if(p[i])
              pstr = pstr + i + ',';
    }
    var scriptcode = doc.createElement('script');
    scriptcode.setAttribute('type', 'text/javascript');
    scriptcode.setAttribute('id', 'RTCScript');
    var text =" function rtcscr(){ var errors = []; function ex(e,pi,el){e=e+', #'+pi+':'+el.localName+': '+String(el.src?el.src:el.location);errors.push(e);} ";
    //text += " var P=[" + p + "]; ";
    if(pi=p[24])
        text += " try{document.documentElement.setAttribute('stopEvents','" + pstr + "');}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    else
        text += " try{document.documentElement.removeAttribute('stopEvents');}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[8])
        text += " try{document.documentElement.setAttribute('stopTimers','true');}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    else
        text += " try{document.documentElement.removeAttribute('stopTimers');}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[29])
        text += " try{Object.freeze=function(obj){return obj;}; Object.seal=function(obj){return obj;}; Object.preventExtensions=function(obj){return obj;};}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[8])
        text += " try{window.setTimeout=function(){}; window.setInterval=function(){};}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[31])
        text += " try{if(document.styleSheets){for(var i=document.styleSheets.length-1; i>=0; i--) {try{if(!document.styleSheets[i]) throw 'err_no_stylesheet'; var cssRules=document.styleSheets[i].cssRules;}catch(ex){continue;} for(var j=cssRules.length-1; j>=0; j--) {if((\/(:|%3A)\\s*hover(?![a-z0-9_\-])\/i).test(cssRules[j].cssText)) {var newcssText = cssRules[j].cssText.replace(\/(:|%3A)\\s*hover(?![a-z0-9_\-])\/ig, function(){var rstr=':lang(RTC';for(var x = 0;x<4; x++) rstr+=String.fromCharCode(97+Math.round(Math.random()*25));return (rstr+')');}); var inc=1; try{document.styleSheets[i].insertRule(newcssText, j);}catch(ex){inc=0;}document.styleSheets[i].deleteRule(j+inc); }}}} }catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[0])
        text += " try{if(window.onfocus) window.onfocus = null;if(window.onblur) window.onblur = null;if(window.onDOMFocusIn) window.onDOMFocusIn = null;if(window.onDOMFocusOut) window.onDOMFocusOut = null;if(window.onDOMActivate) window.onDOMActivate = null;}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[1])
        text += " try{if(window.oncopy) window.oncopy = null;if(window.onselectstart) window.onselectstart = null;if(window.onpaste) window.onpaste= null;if(window.oncut) window.oncut= null;if(window.onselect) window.onselect= null;if(window.onchange) window.onchange= null;}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[2])
        text += " try{if(window.ondragover) window.ondragover = null;if(window.ondrag) window.ondrag = null;if(window.ondragstart) window.ondragstart = null;if(window.ondragenter) window.ondragenter= null;if(window.ondragleave) window.ondragleave= null;if(window.ondrop) window.ondrop= null;}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[5])
        text += " try{if(window.onscroll) window.onscroll= null;if(window.onDOMMouseScroll) window.onDOMMouseScroll= null;}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[3])
        text += " try{if(window.onmouseup) window.onmouseup = null; if(window.onmousedown) window.onmousedown = null;if(window.onclick) window.onclick = null;}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[4])
        text += " try{if(window.oncontextmenu) window.oncontextmenu = null;}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[5])
        text += " try{if(window.onmouseover) window.onmouseover = null;if(window.onmouseout) window.onmouseout = null;if(window.onmousemove) window.onmousemove = null;if(window.onscroll) window.onscroll = null;}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[6])
        text += " try{if(window.ondblclick) window.ondblclick = null;}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[7])
        text += " try{if(window.onkeydown) window.onkeydown = null;if(window.onkeyup) window.onkeyup = null;if(window.onkeypress) window.onkeypress = null;}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[0])
        text += " try{if(document.onfocus) document.onfocus = null;if(document.onblur) document.onblur = null;if(document.onDOMFocusIn) document.onDOMFocusIn = null;if(document.onDOMFocusOut) document.onDOMFocusOut = null;if(document.onDOMActivate) document.onDOMActivate = null;}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[1])
        text += " try{if(document.oncopy) document.oncopy = null;if(document.onselectstart) document.onselectstart = null;if(document.onpaste) document.onpaste= null;if(document.oncut) document.oncut= null;if(document.onselect) document.onselect= null;if(document.onchange) document.onchange= null;}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[2])
        text += " try{if(document.ondragover) document.ondragover = null;if(document.ondrag) document.ondrag = null;if(document.ondragstart) document.ondragstart = null;if(document.ondragenter) document.ondragenter= null;if(document.ondragleave) document.ondragleave= null;if(document.ondrop) document.ondrop= null;}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[5])
        text += " try{if(document.onscroll) document.onscroll= null;if(document.onDOMMouseScroll) document.onDOMMouseScroll= null;}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[3])
        text += " try{if(document.onmouseup) document.onmouseup = null; if(document.onmousedown) document.onmousedown = null;if(document.onclick) document.onclick = null;}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[4])
        text += " try{if(document.oncontextmenu) document.oncontextmenu = null;}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[5])
        text += " try{if(document.onmouseover) document.onmouseover = null;if(document.onmouseout) document.onmouseout = null;if(document.onmousemove) document.onmousemove = null;if(document.onscroll) document.onscroll = null;}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[6])
        text += " try{if(document.ondblclick) document.ondblclick = null;}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[7])
        text += " try{if(document.onkeydown) document.onkeydown = null;if(document.onkeyup) document.onkeyup = null;if(document.onkeypress) document.onkeypress = null;}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[0])
        text += " try{if(document.body.onfocus) document.body.onfocus = null;if(document.body.onblur) document.body.onblur = null;if(document.body.onDOMFocusIn) document.body.onDOMFocusIn = null;if(document.body.onDOMFocusOut) document.body.onDOMFocusOut = null;if(document.body.onDOMActivate) document.body.onDOMActivate = null; }catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[1])
        text += " try{if(document.body.oncopy) document.body.oncopy = null;if(document.body.onselectstart) document.body.onselectstart = null;if(document.body.onpaste) document.body.onpaste= null;if(document.body.oncut) document.body.oncut= null;if(document.body.onselect) document.body.onselect= null;if(document.body.onchange) document.body.onchange= null;}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[2])
        text += " try{if(document.body.ondragover) document.body.ondragover = null;if(document.body.ondrag) document.body.ondrag = null;if(document.body.ondragstart) document.body.ondragstart = null;if(document.body.ondragenter) document.body.ondragenter= null;if(document.body.ondragleave) document.body.ondragleave= null;if(document.body.ondrop) document.body.ondrop= null;}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[5])
        text += " try{if(document.body.onscroll) document.body.onscroll= null;if(document.body.onDOMMouseScroll) document.body.onDOMMouseScroll= null;}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[3])
        text += " try{if(document.body.onmouseup) document.body.onmouseup = null; if(document.body.onmousedown) document.body.onmousedown = null;if(document.body.onclick) document.body.onclick = null;}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[4])
        text += " try{if(document.body.oncontextmenu) document.body.oncontextmenu = null;}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[5])
        text += " try{if(document.body.onmouseover) document.body.onmouseover = null;if(document.body.onmouseout) document.body.onmouseout = null;if(document.body.onmousemove) document.body.onmousemove = null;if(document.body.onscroll) document.body.onscroll = null;}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[6])
        text += " try{if(document.body.ondblclick) document.body.ondblclick = null;}catch(e){e="+pi+"+': '+e;errors.push(e);} ";
    if(pi=p[7])
        text += " try{if(document.body.onkeydown) document.body.onkeydown = null;if(document.body.onkeyup) document.body.onkeyup = null;if(document.body.onkeypress) document.body.onkeypress = null;}catch(e){e="+pi+"+': '+e;errors.push(e);} ";


    text += " var elements = document.getElementsByTagName('*'); for (i = 0; i < elements.length; i++){var el = elements[i]; ";

    if(pi=p[0]){
        text += "  try{if(el.hasAttribute('onfocus')) el.removeAttribute('onfocus');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.hasAttribute('onblur')) el.removeAttribute('onblur');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.hasAttribute('onDOMFocusIn')) el.removeAttribute('onDOMFocusIn');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.hasAttribute('onDOMFocusOut')) el.removeAttribute('onDOMFocusOut');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.hasAttribute('onDOMActivate')) el.removeAttribute('onDOMActivate');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.onfocus) el.onfocus=null;}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.onblur) el.onblur=null;}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.onDOMFocusIn) el.onDOMFocusIn=null;}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.onDOMFocusOut) el.onDOMFocusOut=null;}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.onDOMActivate) el.onDOMActivate=null;}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(window.getComputedStyle(el, null) && window.getComputedStyle(el, null).getPropertyValue('-moz-user-focus') == 'ignore') el.style.setProperty('-moz-user-focus', 'normal', 'important');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(window.getComputedStyle(el, null) && window.getComputedStyle(el, null).getPropertyValue('-moz-user-input') != 'auto') el.style.setProperty('-moz-user-input', 'enabled', 'important');}catch(e){ex(e,"+pi+",el);} ";
    }
    if(pi=p[1]){
        text += "  try{if(el.hasAttribute('onselectstart')) el.removeAttribute('onselectstart');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.hasAttribute('onselect')) el.removeAttribute('onselect');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.hasAttribute('onchange')) el.removeAttribute('onchange');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.hasAttribute('oncopy')) el.removeAttribute('oncopy');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.hasAttribute('onpaste')) el.removeAttribute('onpaste');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.hasAttribute('oncut')) el.removeAttribute('oncut');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(window.getComputedStyle(el, null) && window.getComputedStyle(el, null).getPropertyValue('-moz-user-select') != 'auto') el.style.setProperty('-moz-user-select', 'text', 'important');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(window.getComputedStyle(el, null) && window.getComputedStyle(el, null).getPropertyValue('cursor') != 'auto') el.style.setProperty('cursor', 'auto', 'important');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.onselectstart) el.onselectstart=null;}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.onselect) el.onselect=null;}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.onchange) el.onchange=null;}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.oncopy) el.oncopy=null;}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.onpaste) el.onpaste=null;}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.oncut) el.oncut=null;}catch(e){ex(e,"+pi+",el);} ";
    }
    if(pi=p[4]){
        text += "  try{if(el.hasAttribute('oncontextmenu')) el.removeAttribute('oncontextmenu');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.oncontextmenu) el.oncontextmenu=null;}catch(e){ex(e,"+pi+",el);} ";
    }
    if(pi=p[2]){
        text += "  try{if(el.hasAttribute('ondragenter')) el.removeAttribute('ondragenter');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.hasAttribute('ondragleave')) el.removeAttribute('ondragleave');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.hasAttribute('ondragover')) el.removeAttribute('ondragover');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.hasAttribute('ondrag')) el.removeAttribute('ondrag');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.hasAttribute('ondragstart')) el.removeAttribute('ondragstart');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.hasAttribute('ondrop')) el.removeAttribute('ondrop');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.ondragenter) el.ondragenter=null;}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.ondragleave) el.ondragleave=null;}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.ondragover) el.ondragover=null;}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.ondrag) el.ondrag=null;}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.ondragstart) el.ondragstart=null;}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.ondrop) el.ondrop=null;}catch(e){ex(e,"+pi+",el);} ";
    }
    if(pi=p[3]){
        text += "  try{if(el.hasAttribute('onmouseup')) el.removeAttribute('onmouseup');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.hasAttribute('onmousedown')) el.removeAttribute('onmousedown');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.hasAttribute('onclick')) el.removeAttribute('onclick');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.onmouseup) el.onmouseup=null;}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.onmousedown) el.onmousedown=null;}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.onclick) el.onclick=null;}catch(e){ex(e,"+pi+",el);} ";
    }
    if(pi=p[5]){
        text += "  try{if(el.hasAttribute('onmouseover')) el.removeAttribute('onmouseover');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.hasAttribute('onmouseout')) el.removeAttribute('onmouseout');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.hasAttribute('onmousemove')) el.removeAttribute('onmousemove');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.hasAttribute('onscroll')) el.removeAttribute('onscroll');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.hasAttribute('onDOMMouseScroll')) el.removeAttribute('onDOMMouseScroll');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.onmouseover) el.onmouseover=null;}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.onmouseout) el.onmouseout=null;}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.onmousemove) el.onmousemove=null;}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.onscroll) el.onscroll=null;}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.onDOMMouseScroll) el.onDOMMouseScroll=null;}catch(e){ex(e,"+pi+",el);} ";
    }
    if(pi=p[6]){
        text += "  try{if(el.hasAttribute('ondblclick')) el.removeAttribute('ondblclick');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.ondblclick) el.ondblclick=null;}catch(e){ex(e,"+pi+",el);} ";
    }
    if(pi=p[7]){
        text += "  try{if(el.hasAttribute('onkeydown')) el.removeAttribute('onkeydown');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.hasAttribute('onkeyup')) el.removeAttribute('onkeyup');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.hasAttribute('onkeypress')) el.removeAttribute('onkeypress');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.onkeydown) el.onkeydown=null;}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.onkeyup) el.onkeyup=null;}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.onkeypress) el.onkeypress=null;}catch(e){ex(e,"+pi+",el);} ";
    }
    if(pi=p[20]){
        text += "  try{if(el.hasAttribute('disabled')) el.removeAttribute('disabled');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.hasAttribute('readonly')) el.removeAttribute('readonly');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(window.getComputedStyle(el, null) && window.getComputedStyle(el, null).getPropertyValue('-moz-user-modify') != 'read-write') el.style.setProperty('-moz-user-modify', 'read-write', 'important');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(window.getComputedStyle(el, null) && window.getComputedStyle(el, null).getPropertyValue('resize') != 'both') el.style.setProperty('resize', 'both', 'important');}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.disabled) el.disabled=false;}catch(e){ex(e,"+pi+",el);} ";
        text += "  try{if(el.readonly) el.readonly=false;}catch(e){ex(e,"+pi+",el);} ";
    }
    text += " }";

    text += " var RTCExecuted = document.createElement('div');RTCExecuted.id = 'RTCExecuted';document.body.appendChild(RTCExecuted); RTCExecuted.setAttribute('errors', errors.join('||')); ";
    text += "} ";
    text += " rtcscr(); ";
    text += " var RTCScript = document.getElementById('RTCScript'); RTCScript.parentNode.removeChild(RTCScript); ";

    scriptcode.text = text;
    head_tag.appendChild(scriptcode);

    doc.RTCScriptInjecting = undefined;
    clearTimeout(rtc.blinkTimer);
    m.num = clicked ? 10 : 3;
    rtc.blinkIcon(doc, undefined, m);
},




execute: function(doc, clicked, imgArr) {
    //rtc.log("Parsing " + doc.location.href);
    var win = doc.defaultView;
    if (doc.RTCScriptInjecting) {
        return;
    }
    var elem, i;
    var p = rtc.getPrefs();
    var removeIDs = " ";
    var head_tag = doc.getElementsByTagName('head')[0];
    var m = {}; m.e = [];

    //part 1: check disarming of eventlisteners
    if(p[24]){
        try{
            var cs = win.getComputedStyle(head_tag, null); //hasBinding not yet implemented
            if (cs && !(/rtc[a-z]+\.xml#head/i).test(cs.getPropertyValue('-moz-binding'))
            && !rtcutils.prefs.getBoolPref("extensions.rtc.noWarningBindingErr"))
            {
                var check = {value: false};
                rtc.PROMPTS.alertCheck(null, "RightToClick Warning", "Another addon probably prevents the RightToClick \r\nfunction 'Disarm EventListeners' from being successful!\r\n\r\nThe addon replaced a RightToClick binding \r\nwith: '" + cs.getPropertyValue('-moz-binding') + "'", "Do not show this again", check);
                rtcutils.prefs.setBoolPref("extensions.rtc.noWarningBindingErr", check.value);
            }
        }catch(e){m.e.push("1: " + e);}
    }


    //part 2: Disarm other popup functions
    try {
        if(typeof win.wrappedJSObject != "undefined") {
            if(p[21]) {
                win.wrappedJSObject.showModalDialog = function () {
                    win.wrappedJSObject.showModalDialog = function() {};
                    return null;
                }
            }
        }
    } catch(e) {m.e.push("4: " + e);}


    if(p[25] && !p[26])
        rtc.setStylesDisabled(true, doc); //disable CSS styles

    //part 3: Extract images
    if(p[26])
    {
        var allElements = doc.getElementsByTagName('*'); //search background images
        var url;
        for (i = 0; i < allElements.length; i++)
        {
            if (allElements[i].tagName === "IMG") //foreground images
            {
              if(url = allElements[i].src)
                  imgArr.push(url);
              //continue;
            }
            if (cs = allElements[i].ownerDocument.defaultView.getComputedStyle(allElements[i], null))
            {
                url = cs.getPropertyValue('background-image') || cs.getPropertyValue('background');
                if (url && url.match(/url\s*\('?"?([^'"\)]+)'?"?\)/i))
                {
                    url = String(RegExp.$1);
                    imgArr.push(url);
                }
            }
        }
    }


    //part 4: Disable site's event attributes (needs to be injected in HTML <head> for this) and remove onEvent-attributes
    doc.RTCScriptInjecting = true;
    if (clicked)
      rtc.injectScript(doc, clicked, imgArr, p, head_tag, m);
    else
      window.setTimeout (function(){rtc.injectScript(doc, clicked, imgArr, p, head_tag, m);}, rtcutils.getPref('extensions.rtc.autorundelay'));
},




blinkIcon: function(doc, executed, msg) {
    if (executed)
    {
        while (RTCExecuted = doc.getElementById('RTCExecuted'))
            RTCExecuted.parentNode.removeChild(RTCExecuted);
        var rtcimg = document.getElementById('rtc-statusbarimg');
        var rtcbutton = document.getElementById('RTCButton');
        if(msg.num % 2 == 0) {  //single arrows
            if(rtcimg)   //status bar icon (depreciated)
                rtcimg.setAttribute('src', 'chrome://rtc/skin/' +  ((msg.warn && msg.num) ? 'error-small.png' : 'success-single-small.png'));     //(msg.num ? 'rtc.png' : 'success-single-small.png')
            if(rtcbutton)  //toolbar button
                rtcbutton.setAttribute("status", (msg.warn && msg.num) ? 0 : 1);    //(msg.num ? 1 : 3)
            if(!msg.num)
                return;
        } else if (!msg.warn) { //double arrows
            if(rtcimg)
                rtcimg.setAttribute('src', 'chrome://rtc/skin/success-double-small.png');
            if(rtcbutton)
                rtcbutton.setAttribute("status", 2);
        }
        msg.num--;
    } else if (executed = doc.getElementById('RTCExecuted')) {
        if (err = executed.getAttribute('errors'))
            msg.e = msg.e.concat(err.split('||'));
        while (msg.e.length) {
            var minlevel = 0;
            var ei = msg.e.shift();
            switch (true) {
            case (/Permission\s+denied\s+to\s+access\s+property\s+'setProperty'|:undefined$/).test(ei):
                minlevel = 5;
                break;
            }
            if (rtcutils.getPref('extensions.rtc.log') >= minlevel) {
                msg.warn = true; msg.num = 20;
                rtc.log("A problem was found at URL=" + String(doc.location) + "\r\nDetails: " + ei + "\r\nYou might wish to report it at the RightToClick support forum: http://nc.ddns.us/forum/");
            }
        }

    }
    rtc.blinkTimer = window.setTimeout (function(){rtc.blinkIcon(doc, executed, msg);}, 500);
},



setStylesDisabled: function(disabled, doc) {
    if(gBrowser && gBrowser.markupDocumentViewer){
        gBrowser.markupDocumentViewer.authorStyleDisabled = disabled;
        doc.stylesDisabled = disabled;
    }
},



isValidDocument: function(doc) {
    try{
        var loc = String(doc.location).toLowerCase();
        if ( (doc instanceof HTMLDocument || doc instanceof HTMLIFrameElement)
              && doc.nodeName === '#document'
              && (!loc.indexOf("http") || !loc.indexOf("file"))
              && doc.getElementsByTagName('head')[0]
        )
            return true;
    }catch(e){}
    return false;
},


//pageShow, stop
onShow: function (event) {
    var doc = event.target;
    if(!rtc.isValidDocument(doc))
        return;
    //rtc.log('loc='+doc.location);
    doc.defaultView.addEventListener("beforeunload", rtc.onBeforeUnLoading, false);
    var p = rtc.getPrefs();

    var noPromptDomains = rtcutils.prefs.getCharPref("extensions.rtc.noPromptDomains").split(',');
    var noPromptHere = false;
    for (i = 0; i < noPromptDomains.length; i++)
        if(rtc.getHost(doc.location) === noPromptDomains[i]){
            noPromptHere = true;
            break;
        }

    if(p[22] || noPromptHere) {  //checkbox on first prompt
        rtc.wrapPrompts(doc, doc.defaultView, undefined);
        if(noPromptHere)
            rtc.nullPrompts(true, doc.defaultView, undefined);
    }

    if(!p[23]) {
        var alwaysRun = false;
        var alwaysRunDomains = rtcutils.prefs.getCharPref("extensions.rtc.alwaysRunDomains").split(',');
        for (i = 0; i < alwaysRunDomains.length; i++)
           if(rtc.getHost(doc.location) === alwaysRunDomains[i]){
              alwaysRun = true;
              break;
           }
    }

    if (p[23] || alwaysRun)
        //window.setTimeout(rtc.run, 500, doc, false);
        window.setTimeout (function(){rtc.runOnEvent(event, false);}, 500);     //doc not dead

    window.setTimeout (function(){rtc.removeXMLScr(event);}, 5000);   //doc not dead
},




removeXMLScr: function (event) {
    var doc;
    var isDead = false;
    try{ isDead = Components.utils.isDeadWrapper(event.target); }catch(e){}
    if(!isDead)
      doc = event.target;
    if(doc)
      while (RTCEarlyScript = doc.getElementById('RTCEarlyScript')) RTCEarlyScript.parentNode.removeChild(RTCEarlyScript);
},





//no longer needed since wrapPrompts is called on pageshow, but leaving it for safety
onDialog: function (event) {
    var p = rtc.getPrefs();
    if(p[22])
        rtc.wrapPrompts(event.target.document, event.target.document.defaultView, event);
},


onBeforeUnLoading: function (event) {
    event.originalTarget.defaultView.removeEventListener("beforeunload", rtc.onBeforeUnLoading, false);
    if(event.originalTarget.stylesDisabled)
        rtc.setStylesDisabled(false, event.originalTarget);
},


nullPrompts: function (checked, win, event) {
    if (checked) {
        win.wrappedJSObject.alert = function() {};
        win.wrappedJSObject.confirm = function() {};
        win.wrappedJSObject.prompt = function() {};
        if(event) {
            event.preventDefault();
            try{event.stopImmediatePropagation();}catch(e){}
            event.stopPropagation();
        }
    }
},


//part 4: Disarm prompts (add a checkbox)
//it seems FF4 does not always recognize repeated prompts, thus not removing this functionality
wrapPrompts: function (doc, win, event) {
    if(win.RTCdone || typeof win.wrappedJSObject == "undefined")
        return false;
    var domain;
    try{
        domain = doc.domain;
    }catch(e){}
    var titlemsg = domain ? ("The page at " + doc.domain + " says: ") : "Javascript Application";
    var checkmsg = "Stop dialog popups on this page";
    var check = {value: false};

    win.wrappedJSObject.alert = function (message)
    {
        rtc.PROMPTS.alertCheck(win, titlemsg, message, checkmsg, check);
        rtc.nullPrompts(check.value, win, event);
        return undefined;
    }
    win.wrappedJSObject.confirm = function (message)
    {
        var val = rtc.PROMPTS.confirmCheck(win, titlemsg, message, checkmsg, check);
        rtc.nullPrompts(check.value, win, event);
        return val;
    }
    win.wrappedJSObject.prompt = function (message, val)
    {
        var input = {value: String(val)};
        var val = rtc.PROMPTS.prompt(win, titlemsg, message, input, checkmsg, check);
        rtc.nullPrompts(check.value, win, event);
        if(val)
                return input.value;
        return null;
    }
    win.RTCdone = true;
    return true;
},



pageInfo: function () {
    var doc = null;
    var initialTab = "mediaTab";
    if(rtc.WM && rtc.WM.getMostRecentWindow("navigator:browser")
    && rtc.WM.getMostRecentWindow("navigator:browser").content)
               doc = rtc.WM.getMostRecentWindow("navigator:browser").content.document;
    var args = {doc: doc, initialTab: "securityTab"};
    window.openDialog('chrome://browser/content/pageinfo/pageInfo.xul', '_blank', 'chrome,toolbar,dialog=no,resizable', args);
},



chooseBinding: function (disarmObjProt) {
    if(disarmObjProt){
        rtc.UnregisterBinding("chrome://rtc/content/rtcDefault.css");
        rtc.RegisterBinding("chrome://rtc/content/rtcProtObj.css");
    }else {
       rtc.UnregisterBinding("chrome://rtc/content/rtcProtObj.css");
       rtc.RegisterBinding("chrome://rtc/content/rtcDefault.css");
    }
},



RegisterBinding: function (cssFile) {
    var sss = Components.classes["@mozilla.org/content/style-sheet-service;1"]
        .getService(Components.interfaces.nsIStyleSheetService);
    var rtcss = rtc.IOS.newURI(cssFile, null, null);
    if ( !sss.sheetRegistered(rtcss, sss.USER_SHEET) )
            sss.loadAndRegisterSheet(rtcss, sss.USER_SHEET);
},

UnregisterBinding: function (cssFile) {
    var sss = Components.classes["@mozilla.org/content/style-sheet-service;1"]
        .getService(Components.interfaces.nsIStyleSheetService);
    var rtcss = rtc.IOS.newURI(cssFile, null, null);
    if ( sss.sheetRegistered(rtcss, sss.USER_SHEET) )
      sss.unregisterSheet(rtcss, sss.USER_SHEET);
},


getUpdateFlag: function (pos) {
  var updateflag = rtcutils.getPref("extensions.rtc.updateflag");
  return ((pos < updateflag.length) ? Number(updateflag[pos]) : 0);
},

setUpdateFlag: function (pos, val) {
  var updateflag = rtcutils.getPref("extensions.rtc.updateflag");
  updateflag = (pos < updateflag.length) ? (updateflag.substr (0, pos) + String (val) + updateflag.substr (pos + String(val).length)) : (updateflag + String(val));
  rtcutils.setPref("extensions.rtc.updateflag", updateflag);
},


AddButtonToToolbar: function () {


    function addButton (bar, buttonId) {
        try{
            var curSet = bar.currentSet.split(",");
            if (curSet.indexOf(buttonId) == -1)
            {
                  var pos = curSet.length < 40 ? curSet.length : 3;
                  var set = curSet.slice(0, pos).concat(buttonId).concat(curSet.slice(pos));
                  bar.setAttribute("currentset", set.join(","));
                  bar.currentSet = set.join(",");
                  document.persist(bar.id, "currentset");
                  try{
                      BrowserToolboxCustomizeDone(true);
                  }catch(e) {}
            }
        }catch(e) {}
    }

    var navBar = document.getElementById("nav-bar");
    var addonBar = document.getElementById("addon-bar");
    var buttonId = 'RTCButton';
    var updateflag = rtc.getUpdateFlag(0);
    switch (updateflag) {
        case 0:                                   //First install
            if(addonBar && !addonBar.collapsed){   //FF4 with addon-bar
                addButton(addonBar, buttonId);
                updateflag = 2;
            }else if(addonBar && navBar){          //FF4 with addon-bar, but not used
                addButton(navBar, buttonId);
                updateflag = 2;
            }else if(navBar){                      //not FF4, do nothing yet, try updating later
                addButton(navBar, buttonId);
                updateflag = 1;
            }
            break;
        case 1:                                   //RTC already installed
            if(addonBar && !addonBar.collapsed){  //updated to FF4 with addon-bar
                addButton(addonBar, buttonId);
                updateflag = 2;
            }else if(addonBar && navBar){          //updated to FF4 with addon-bar, but not used, do nothing
                updateflag = 2;
            }else if(navBar){                      //not FF4, do nothing yet, try updating later
                updateflag = 1;
            }
            break;
        default:
        break;
    }
    rtc.setUpdateFlag(0,updateflag);
},





getPrefs: function (forGUI) {
    var defprefstr = prefstr = rtcutils.prefs.getCharPref("extensions.rtc.prefsdefault");
    try {  //first add-on install: only default prefs are defined, thus here an exception
        prefstr = rtcutils.prefs.getCharPref("extensions.rtc.prefs");
        if(defprefstr.length > prefstr.length)
            prefstr = prefstr.concat(defprefstr.slice(prefstr.length));
    }catch(e) {
        rtcutils.prefs.setCharPref("extensions.rtc.prefs", defprefstr);
    }
    var p = prefstr.split(",");
    for(var i = 0; i < p.length; i++)    //reflect disabled states of elements
        p[i] = (!forGUI && Number(p[i]) < 0) ? 0 : (Math.abs(Number(p[i])));
    return p;
},


savePrefs: function(p)  {
    var prefstr = p.join(",");
    rtcutils.prefs.setCharPref("extensions.rtc.prefs", prefstr);
},




optionsReset: function(selector) {
    var defaults = rtcutils.prefs.getCharPref("extensions.rtc.prefsdefault");
    rtcutils.clearPref("extensions.rtc.prefsdefault");
    rtcutils.prefs.setCharPref("extensions.rtc.prefs", defaults);
    rtc.chooseBinding (Number(defaults.split(",")[29]));
    if (selector == 1) return;
    rtcutils.clearPref("extensions.rtc.noPromptDomains");
    rtcutils.clearPref("extensions.rtc.alwaysRunDomains");
    rtcutils.clearPref('extensions.rtc.log');
    if (selector == 2) return;
    rtc.optionsLoad();
    rtc.optionsModified();
},



optionsLoad: function() {
    var ver = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo).version;
    var p = rtc.getPrefs(true);
    for (var i = 0; i < p.length; i++)
    {
        if(el = document.getElementById(String(i))) {
            if (el.nodeName == "checkbox")
                el.checked = p[i];
            else if (el.nodeName == "radiogroup")
                el.selectedIndex = p[i];
        }
    }
    rtc.optionsModified();
    if (rtcutils.getPref('extensions.rtc.statusbar'))
        document.getElementById('28').hidden = false;
    else
        document.getElementById('28').hidden = true;  //no statusbar in FF 4
    //RTC shortcut key:
    var modifier = rtcutils.getPref("extensions.rtc.keymodifiers") + " + ";
    var modifierTag = document.getElementById("KeyCodeModifier");
    modifierTag.value = modifier;
    modifierTag.label = modifier;
    modifierTag.title = modifier;
    if (rtcutils.getPref("extensions.rtc.keycode"))
        document.getElementById ("KeyCodeBox").value = String.fromCharCode(rtcutils.getPref("extensions.rtc.keycode"));
    if (Number(ver.replace("\..*", "","")) > 3) {
      document.getElementById("22").checked = false;
      document.getElementById("22").hidden = true;
    } else
      document.getElementById("22").hidden = false;
    document.getElementById("30").checked = !rtcutils.prefs.getBoolPref ("dom.event.contextmenu.enabled");
    document.getElementById("log").checked = (rtcutils.getPref("extensions.rtc.log") > (-1)) ? true : false;
    if (hlppageinfo = document.getElementById("hlppageinfo"))
      hlppageinfo.addEventListener("mouseup", rtc.pageInfo, false);
},




optionsSave: function() {
    var p = rtc.getPrefs();
    for(var i = 0; i < p.length; i++)
    {
        if (el = document.getElementById(String(i))) {
            var avail = !el.disabled;  //reflect disabled states of elements
            if (el.nodeName == "checkbox")
                var elval = el.checked - 0;
            else if (el.nodeName == "radiogroup")
                var elval = el.selectedIndex;
            p[i] = avail ? (Math.abs(elval)) : (Math.abs(elval)*(-1));
        }
    }

    rtc.savePrefs(p);
    rtc.chooseBinding(p[29]);
    var noPromptDomains = document.getElementById("noPromptDomains").value.split(',');
    for(var i = 0; i < noPromptDomains.length; i++)
        noPromptDomains[i] = rtc.getHost(noPromptDomains[i]);
    rtcutils.prefs.setCharPref("extensions.rtc.noPromptDomains",
    noPromptDomains.join(',').replace(/[,\s]+/g,',').replace(/^[,\s]+|[,\s]+$/g,''));
    var alwaysRunDomains = document.getElementById("alwaysRunDomains").value.split(',');
    for(var i = 0; i < alwaysRunDomains.length; i++)
        alwaysRunDomains[i] = rtc.getHost(alwaysRunDomains[i]);
    rtcutils.prefs.setCharPref("extensions.rtc.alwaysRunDomains",
    alwaysRunDomains.join(',').replace(/[,\s]+/g,',').replace(/^[,\s]+|[,\s]+$/g,''));
    //RTC shortcut key:
    var keycodeBox = document.getElementById ("KeyCodeBox");
    if(keycodeBox){
        var value = keycodeBox.value ? keycodeBox.value.charCodeAt(0) : 0;
        rtcutils.setPref("extensions.rtc.keycode", value);
    }
    rtcutils.prefs.setBoolPref("dom.event.contextmenu.enabled", !document.getElementById("30").checked);
    var preflog = rtcutils.getPref("extensions.rtc.log");
    if (document.getElementById("log").checked && preflog < 0)
        rtcutils.setPref("extensions.rtc.log", 4);
    else if (!document.getElementById("log").checked && preflog > -1)
        rtcutils.clearPref("extensions.rtc.log");
    Components.classes["@mozilla.org/preferences-service;1"]
        .getService(Components.interfaces.nsIPrefService).savePrefFile(null);
},


optionsSetKeys: function() {
    var kNode = document.getElementById("key_rtc");
    if(kNode)
    {
        var keyCode = rtcutils.getPref("extensions.rtc.keycode");
        if(keyCode){
            kNode.setAttribute("disabled", false);
            kNode.setAttribute("modifiers", String(rtcutils.getPref("extensions.rtc.keymodifiers")));
            kNode.setAttribute("key", String.fromCharCode(keyCode));
        }
    }
},



optionsModified: function (event) {
    var jsOptionsGrp = document.getElementById("jsOptionsGrp");
    var elems = jsOptionsGrp.getElementsByTagName('checkbox');
    var oneEnabled = false;
    for (var i=0; i < elems.length-2; i++) {    //note: length-2 to exclude timers and event-listener checkbox!
        if (elems[i] && elems[i].checked && !elems[i].disabled) {
            oneEnabled = true;
            break;
        }
    }
    if (oneEnabled)
        document.getElementById("24").disabled = false;
    else
        document.getElementById("24").disabled = true;
    if(document.getElementById("26").checked)
        document.getElementById("25").disabled = true;
    else
        document.getElementById("25").disabled = false;
    if(document.getElementById("23").checked){
        document.getElementById("alwaysRunDomains").disabled = true;
        document.getElementById("alwaysRunDomainsLabel").disabled = true;
    }else{
        document.getElementById("alwaysRunDomains").disabled = false;
        document.getElementById("alwaysRunDomainsLabel").disabled = false;
    }
    if(event && event.target.id == "25")
    {
        if(document.getElementById("25").checked && !rtcutils.prefs.getBoolPref("extensions.rtc.noWarningDisableCSS")){
            check = {value: false};
            if(!rtc.PROMPTS.confirmCheck(null, "RightToClick", "Disabling CSS usually makes pages look strange but might help to save images.\r\n\r\nStill disable CSS?", "Do not show this again", check))
                document.getElementById(event.target.id).checked = false;
            rtcutils.prefs.setBoolPref("extensions.rtc.noWarningDisableCSS", check.value);
        }
    }
    if(event && event.target.id == "29")
    {
        if(document.getElementById("29").checked && !rtcutils.prefs.getBoolPref("extensions.rtc.noWarningCheckObjProt")){
            check = {value: false};
            if(!rtc.PROMPTS.confirmCheck(null, "RightToClick warning", "In some rare cases this can break script functionality!\r\n(note: Already shown pages need to be reloaded)\r\n\r\nStill enable this setting?", "Do not show this again", check))
                document.getElementById(event.target.id).checked = false;
            rtcutils.prefs.setBoolPref("extensions.rtc.noWarningCheckObjProt", check.value);
        }
    }
    document.getElementById("noPromptDomains").value = rtcutils.prefs.getCharPref("extensions.rtc.noPromptDomains");
    document.getElementById("alwaysRunDomains").value = rtcutils.prefs.getCharPref("extensions.rtc.alwaysRunDomains");
},



optionsStatBarIcon: function (visible) {
  if(!rtc.getMainOverlay().getElementById("rtcstatusbarID"))
      return;
  if (rtcstatusbarimg = document.getElementById("rtc-statusbarimg"))
       rtcstatusbarimg.addEventListener("stop", rtc.captureClick, true);
  if(visible)
      rtc.getMainOverlay().getElementById("rtcstatusbarID").setAttribute('collapsed', false);
  else
      rtc.getMainOverlay().getElementById("rtcstatusbarID").setAttribute('collapsed', true);
},



optionsHelpPage: function (aNode, deltaPages) {
    var maxItemsPerPage = 2;
    var targetPage = Number(aNode.parentNode.getAttribute('value')) + deltaPages;
    if(isNaN(targetPage) || targetPage < 1 || !document.getElementById('d'+targetPage))
        return;
    aNode.parentNode.setAttribute('value', targetPage);
    var i = 1;
    while(document.getElementById('d'+i)) {
        if(!deltaPages || i == targetPage * maxItemsPerPage || i == targetPage * maxItemsPerPage - 1)
            document.getElementById('d'+i).style.setProperty('display', 'inline', 'important');
        else
            document.getElementById('d'+i).style.setProperty('display', 'none', 'important');
        i++;
    }
    document.getElementById("backBtn").style.setProperty('visibility', targetPage > 1 && deltaPages ? 'visible' : 'hidden', 'important');
    document.getElementById("forwardBtn").style.setProperty('visibility', targetPage * maxItemsPerPage !== i && deltaPages ? 'visible' : 'hidden', 'important');
},



getMainOverlay: function () {
  return Components.classes["@mozilla.org/appshell/window-mediator;1"]
         .getService(Components.interfaces.nsIWindowMediator)
         .getMostRecentWindow("navigator:browser").document;
},


};




window.addEventListener("load", rtc.Init, false);