

var rtcutils = {
    prefs: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch),

    getPref: function(prefName, prefType)
    {
        try{
          prefType = prefType ? prefType : rtcutils.prefs.getPrefType(prefName);
        }catch(e){}
        if (prefType === 32)
            return rtcutils.prefs.getCharPref(prefName);
        else if (prefType === 64)
            return rtcutils.prefs.getIntPref(prefName);
        else if (prefType === 128)
            return rtcutils.prefs.getBoolPref(prefName);
        else
            return undefined;
    },

    setPref: function(prefName, val, prefType)
    {
        try{
          prefType = prefType ? prefType : rtcutils.prefs.getPrefType(prefName);
        }catch(e){}
        if (prefType === 32)
            rtcutils.prefs.setCharPref(prefName, val);
        else if (prefType === 64)
            rtcutils.prefs.setIntPref(prefName, val);
        else if (prefType === 128)
            rtcutils.prefs.setBoolPref(prefName, val);
        else
            alert("Invalid preference "+prefName+" check that it is listed in defaults/rtcprefs.js");

    },

    clearPref: function(prefName)
    {
        //if (rtcutils.prefs.prefHasUserValue(prefName))
        try{ rtcutils.prefs.clearUserPref(prefName); }catch(e){}
    },


    isUserPref: function(prefName)
    {
        return rtcutils.prefs.prefHasUserValue(prefName);
    },

};